{-------------------------------------------------------------}
{
{    Programa de navegao bsica na WEB (HTTP)
{
{    Autores: Jose' Antonio Borges e Bernard Condorcet Porto
{
{    Em 11/04/98
{
{-------------------------------------------------------------}

uses
     windows, shellApi, sysUtils, webutil,
     dvcrt, dvWin, winsock, dvinet, dvForm, dvhora, dvjpeg, dvExec,
     webVars, webUrl, webConf, webGrArq, webleit, webMsg, webTraz, webGrava,
     webBMark, webCarta, webBusca, webCatal, webCook;

{-------------------------------------------------------------}
{                     rotina de inicializacao
{-------------------------------------------------------------}

procedure inicializa (falarAbertura: boolean); //Neno
var s: string;
    erro: integer;
    c: char;
    dir: string;

begin
    clrscr;
    setWindowText (crtWindow, 'WEBVOX');

    debug := false;
    mudo := false;
    dir := sintambiente ('WEBVOX', 'DIRWEBVOX');
    if dir = '' then
        dir := sintAmbiente('DOSVOX', 'PGMDOSVOX') + '\som\webvox';
    sintInic (obtemInt(sintAmbiente('WEBVOX', 'VELOCIDADE'), 0), dir); //Neno

    usaSapi := falandoSapi;
    tipoSapi1 := obtemInt (sintAmbiente ('SERVFALA', 'TIPOSAPI'), 1);
    vozSapi1 := obtemInt (sintAmbiente ('SERVFALA', 'VOZ'), 1);
    velSapi1 := obtemInt (sintAmbiente ('SERVFALA', 'VELOCIDADE'), 220);
    tomSapi1 := obtemInt (sintAmbiente ('SERVFALA', 'TOM'), 110);
    tipoSapi2 := obtemInt (sintAmbiente ('WEBVOX', 'TIPOSAPI'), 1);
    if tipoSapi2 <= 0 then tipoSapi2 := 4;
    vozSapi2 := obtemInt (sintAmbiente ('WEBVOX', 'VOZSAPI'), 1);
    velSapi2 := obtemInt (sintAmbiente ('WEBVOX', 'VELOCSAPI'), 220);
    tomSapi2 := obtemInt (sintAmbiente ('WEBVOX', 'TOMSAPI'), 110);
    modoFala := upcase((sintAmbiente ('WEBVOX', 'MODOFALA') + 'N')[1]);

    arqCookie := sintambiente ('WEBVOX','ARQWEBCOOKIES');
    if arqCookie = '' then
       arqCookie := sintDirAmbiente + '\webcookies.ini';

    nomeWebselec := sintambiente ('WEBVOX','ARQWEBSELEC');
    if nomeWebselec = '' then
       nomeWebselec := sintDirAmbiente + '\webselec.ini';

    nomeWebcatal := sintambiente ('WEBVOX','ARQWEBCATAL');
    if nomeWebcatal = '' then
       nomeWebcatal := sintDirAmbiente + '\webcatal.ini';

    s := sintAmbiente ('WEBVOX', 'FALARCARREGAMENTO') + 'S'; // no mnimo uma letra
    c := s[1];
    falarCarregamento := upcase (c) <> 'N';

    ultimoLinkLido := '';
    inicCookies;

    if falarAbertura then //Neno
        begin
            mensagem ('WBINIC', 0);   {'Leitor de pginas WEB - NCE/UFRJ - v'}
            write (VERSAO);
            sintetiza (VERSAO);
            sintWriteln (ALFABETA);
        end
    else
        begin
            write (pegaTextoMensagem('WBINIC'));   {'Leitor de pginas WEB - NCE/UFRJ - v'}
            write (VERSAO);
            writeln (ALFABETA);
        end;
    writeln;

    if not abreWinSock then
        mensagem ('WBERRCOM', 1);  {'No consegui ativar o sistema de comunicao do micro'}

    portaHTTP := 80;
    nomeTemp := '';
    nomePagAtual := '';
    topoPilhaPag := 0;
    nlinCabecHTTP := 0;
    ntags := 0;
    linhaAtual := 1;
    nomeBase := '';
    emPortug := true;
    rotuloInicial := '';
    textoBuscado :=  sintambiente ('WEBVOX','TEXTOBUSCADO');
    nSomTags := 0;
    falandoPontuacao := upcase((sintAmbiente('WEBVOX', 'FALANDOPONTUACAO') + 'N')[1]) = 'S';
    portaLocalFTP := 1050;
    modoFala := upcase((sintAmbiente ('WEBVOX', 'MODOFALA') + 'N')[1]);

    ultMsgAutent := '@#$%@';
    ultAutent := '@#$%@';

    new (tagsPagina);
    getMem (dadosPost, 206000);     // preliminar, s transmite at 200 K

    nTagsForms := 0;
    new (tagsForms);

    {Bernard}
    titCatal:= nomeWebSelec;
    carregaBookMarks;

    s :=  sintAmbiente ('WEBVOX', 'COMPROXY');
    comProxy := (s <> '') and (upcase (s[1]) = 'S');

    s := sintAmbiente ('WEBVOX', 'ENDERPROXY');
    if s <> '' then
        hostProxy := s
    else
        hostProxy := PROXY_NCE;

    s := sintAmbiente ('WEBVOX', 'PORTAPROXY');
    if s <> '' then
        val (s, portaProxy, erro)
    else
        portaProxy := PORTAPROXY_NCE;

    dirTags := sintAmbiente ('WEBVOX', 'DIRSOMTAGS');
    if dirTags = '' then dirTags := sintAmbiente('DOSVOX', 'PGMDOSVOX') + '\som\somtags';

    s := sintAmbiente ('WEBVOX', 'AMBWEBTAGS');
    if s = '' then s := sintDirAmbiente + '\webtags.ini';

    if modoFala in ['R', 'T'] then //Neno
        prepSonsTags ('')
    else
        prepSonsTags (s);

    dirDownload := sintAmbiente ('WEBVOX', 'DIRDOWNLOAD');
    if uppercase(dirDownload) = '*DOWNLOADS' then
        begin
            dirDownload := getMeusDownloads;
            sintGravaAmbiente( 'WEBVOX', 'DIRDOWNLOAD', dirDownload);
        end;

end;

{-------------------------------------------------------------}
{                 edita pagina com editor de textos
{-------------------------------------------------------------}

procedure chamarEditor;
var nomeArq, nomeEditor: string;
    c, c2: char;
    tempPath, tempFileName: array [0..144] of char;
    geraRef: boolean;
begin
    if nomeTemp = '' then
        begin
            mensagem ('WBNAOCAR', 1);  {'No existe pgina carregada'}
            exit;
        end;

    getTempPath (144, tempPath);
    getTempFileName(tempPath, 'wbe', 0, tempFileName);
    nomeArq := strPas (tempFileName);

    mensagem ('WBQUEREF', 0);  {'Deseja referncias listadas no texto ? '}
    sintLeTecla (c, c2);
    writeln;
    geraRef := upcase (c) = 'S';

    if not geraArqTexto (nomeTemp, nomeArq, geraRef) then
        begin
            mensagem ('WBERRTXT', 1);  {'Erro ao gravar o arquivo texto'}
            exit;
        end;

    nomeEditor := sintAmbiente ('WEBVOX', 'EDITOR');
    if nomeEditor = '' then
        nomeEditor := sintAmbiente ('DOSVOX', 'MINIED');
    if nomeEditor = '' then
        nomeEditor := sintAmbiente('DOSVOX', 'PGMDOSVOX') + '\minied.exe';
    while sintFalando do waitMessage;

    mensagem ('WBABREDI', 2);  {'Abrindo editor'}
    if executaProg (nomeEditor, '', nomeArq) > 32 then
        begin
            delay (3000);
            esperaProgVoltar;
        end
    else
        mensagem ('WBERREDI', 1);    {'Erro ao acionar o editor de textos'}

    {$I-} DeleteFile (nomeArq);  {$I+}
    if ioresult <> 0 then;
end;

{-------------------------------------------------------------}
{                 exportar texto para clipboard
{-------------------------------------------------------------}

procedure exportarPagina;
var
    p: PChar;
    pos, tam: word;
    arq: text;
    nomeArq, texto: string;
    tempPath, tempFileName: array [0..144] of char;
begin
    if nomeTemp = '' then
        begin
            mensagem ('WBNAOCAR', 1);  {'No existe pgina carregada'}
            exit;
        end;

    getTempPath (144, tempPath);
    getTempFileName(tempPath, 'web', 0, tempFileName);
    nomeArq := strPas (tempFileName);
    geraArqTexto (nomeTemp, nomeArq, false);

    assign (arq, nomeArq);
    {$I-}  reset (arq);  {$I+}
    if ioresult <> 0 then
        begin
            mensagem ('WBTRAAPA', 1);  {'Arquivo de trabalho foi apagado'}
            exit;
        end;

    getmem (p, 65000);
    pos := 0;
    while not eof (arq) do
        begin
            readln (arq, texto);
            tam := length (texto);
            if (longint (pos) + tam + 2) > 65000 then
                begin
                    mensagem ('WBCOPTRU', 1);  {'No cabe na rea de transferncia'}
                    break;
                end;

            if tam > 0 then
                move (texto[1], p[pos], tam);
            pos := pos + tam;
            p[pos]   := #$0d;
            p[pos+1] := #$0a;
            pos := pos + 2;
        end;
    closefile (arq);

    p[pos] := #$0;
    putClipboard (p);

    mensagem ('WBBLKCPY', 1);  {'Bloco copiado'}
    freemem (p, 65000);
    erase (arq);
end;

{-------------------------------------------------------------}
{                     finaliza o programa
{-------------------------------------------------------------}

procedure finaliza (falarTerminado: boolean); //Neno
var arq: file;
begin
    finalizaCookies;
    fechaWinSock;

    dispose (tagsPagina);
    freeMem (dadosPost, 10000);

    while topoPilhaPag > 0 do
        begin
            if pilhaPag [topoPilhaPag]^.podeApagarTemp then
                begin
                    assign (arq, pilhaPag [topoPilhaPag]^.nomeArqTemp);
                    {$I-}  erase (arq);  {$I+}
                    if ioresult <> 0 then;
                end;
            topoPilhaPag := topoPilhaPag - 1;
        end;

    if falarTerminado then //Neno
        mensagem ('WBFIM', 1);  {'Acesso  WEB terminado'}
    sintFim;

    doneWinCrt;
end;

{-------------------------------------------------------------}
{                     testa se quer terminar
{-------------------------------------------------------------}

procedure fim;
var c: char;
begin
    mensagem ('WBCNFFIM', 0);  {'Confirma fim (s/n): '}
    c := popupMenuPorLetra ('SN');
    writeln (c);

    if upcase (c) = 'S' then
        processando := false;
end;

{-------------------------------------------------------------}
{                   guarda pgina preferida
{-------------------------------------------------------------}

procedure guardaPagPreferida;
var
    pagPreferida: string;
    c: char;
begin
    pagPreferida := nomePagAtual;
    mensagem ('WBEDPREF', 1);       {'Editore o nome da pgina preferida'}
    c := sintEditaCampo (pagPreferida, wherex, wherey, 255, 80, true);
    writeln ;
    if c = ESC then
        begin
            mensagem ('WBDESIST', 1);  {'Desistiu'}
            exit;
        end;

    sintGravaAmbiente ('WEBVOX', 'PREFERIDA', pagPreferida);
    mensagem ('WBOK', 1);       {'OK'}
end;

{-------------------------------------------------------------}
{                          ajuda
{-------------------------------------------------------------}

procedure ajuda;
begin
   mensagem ('WBAJU01', 1);  {'As opes so:'}
   mensagem ('WBAJU02', 1);  {'  T    trazer pgina da rede'}
   mensagem ('WBAJU03', 1);  {'  L    ler pgina'}
   mensagem ('WBAJU04', 1);  {'  V    voltar  ltima lida'}
   mensagem ('WBAJU05', 1);  {'  S    pginas selecionadas'}
   mensagem ('WBAJU06', 1);  {'  A    trazer a pgina de um arquivo local'}
   mensagem ('WBAJU07', 1);  {'  G    gravar pgina'}
   mensagem ('WBAJU08', 1);  {'  O    gravar no formato original'}
   mensagem ('WBAJU09a', 1); {'  X    exportar texto da pgina para rea de transferncia'}
   mensagem ('WBAJU10', 1);  {'  C    configurar o programa'}
   mensagem ('WBAJU12', 1);  {'  N    trazer pgina sem ler'}
   mensagem ('WBAJU13', 1);  {'  R    recarregar esta pgina'}
   mensagem ('WBAJU14', 1);  {'  P    guarda pgina preferida'}
   mensagem ('WBAJU15', 1);  {'  E    enviar pgina por email'}
   mensagem ('WBAJU16', 1);  {'  B    carregar pginas do buscador'}
   mensagem ('WBAJU19', 1);  {'  ESC  terminar o programa'}

   while keypressed do readkey;
end;

{-------------------------------------------------------------}
{               seleciona a opo com as setas
{-------------------------------------------------------------}

    procedure MenuAdiciona (msg: string);
    begin
         popupMenuAdiciona (msg, pegaTextoMensagem (msg));
    end;

function selSetasOpcao: char;
var n: integer;
const
    tabLetrasOpcoes: string [14] = 'tlvsagoxcnrpeb';

begin
    popupMenuCria (wherex, wherey, 60, 15, MAGENTA);
    MenuAdiciona ('WBAJU02');  {'  T    trazer pgina da rede'}
    MenuAdiciona ('WBAJU03');  {'  L    ler pgina'}
    MenuAdiciona ('WBAJU04');  {'  V    voltar  ltima lida'}
    MenuAdiciona ('WBAJU05');  {'  S    pginas selecionadas'}
    MenuAdiciona ('WBAJU06');  {'  A    trazer a pgina de um arquivo local'}
    MenuAdiciona ('WBAJU07');  {'  G    gravar pgina'}
    MenuAdiciona ('WBAJU08');  {'  O    gravar no formato original'}
    MenuAdiciona ('WBAJU09a'); {'  X    exportar texto da pgina para rea de transferncia'}
    MenuAdiciona ('WBAJU10');  {'  C    configurar o programa'}
    MenuAdiciona ('WBAJU12');  {'  N    trazer pgina sem ler'}
    MenuAdiciona ('WBAJU13');  {'  R    recarregar esta pgina'}
    MenuAdiciona ('WBAJU14');  {'  P    guarda pgina preferida'}
    MenuAdiciona ('WBAJU15');  {'  E    envia pgina por email'}
    MenuAdiciona ('WBAJU16');  {'  B    carregar pginas do buscador'}
    n := popupMenuSeleciona;
    if n > 0 then
        selSetasOpcao := tabLetrasOpcoes[n]
    else
        selSetasOpcao := ENTER;
end;

{-------------------------------------------------------------}
{                     programa principal
{-------------------------------------------------------------}

var c1, c2: char;
    s, nome: string;
    ok, ehArquivo, falarAbertura: boolean;
    voltando: boolean;
    i: integer;

label executa;
begin
    processando := true;
    falarAbertura := true;

    nome := sintAmbiente('WEBVOX', 'PREFERIDA');
    for i := 1 to paramCount do
        if upperCase(paramStr(i)) = '/M' then
            falarAbertura := false
        else
            nome := paramStr(i);

    inicializa (falarAbertura);

    if nome <> '' then
        begin
            ehArquivo := false;
            if nome [1] = '"' then
                begin
                    ehArquivo := true;
                    delete (nome, 1, 1);
                    if copy (nome, length(nome), 1) = '"' then
                        delete (nome, length(nome), 1);
                end
            else
                if (pos ('\', nome) <> 0) or (pos (':', nome) = 2) or (FileExists(nome)) then
                    ehArquivo := true;

            if ehArquivo then
                ok := carregarArquivo (nome)
            else
                begin
                    completaEsquema (nome);
                    ok := trazerPagina (nome, 'G');
                end;

            if ok then
                lerPagina (voltando)
            else
                mensagem ('WBPAGNAO', 1);  {'Pgina no achada'}
        end;

    if falarAbertura then processando := true; //Neno
//Neno    processando := true;
    c1 := ' ';
    while (processando)  do
       begin
           textBackground (BLUE);
           if c1 <> NOFOCUS then mensagem ('WBQUALOP', 0);  {'Qual sua opo ? '}
           textBackground (BLACK);

           checkFocus := true;
           sintLeTecla (c1, c2);
           checkFocus := false;
           if c1 <> NOFOCUS then writeln;

           if (c1 = #0) and ((c2 = CIMA) or (c2 = BAIX)) then
                begin
                    c1 := selSetasOpcao;
                    goto executa;
                end
           else
           if (c1 = #0) and (c2 = F1) then
               ajuda
           else
           if (c1 = #0) and (c2 = CTLF8) then
               falaDia
           else
executa:
           if c1 = #0 then
               case c2 of
                   F1:  ajuda;
                   F3:  begin
                           if nomePagAtual = '' then
                              mensagem ('WBNAOCAR', 1)   {'No existe pgina carregada'}
                           else
                              begin
                                 mensagem ('WBEDIT',1);
                                 s := paginaQueFoiAberta;
                                 c1 := sintEditaCampo (s,wherex,wherey,255,80,true);
                                 if c1 <> ESC then
                                    begin
                                       writeln;
                                       nomePagAtual := s;
                                       if trazerPagina (s, 'G') then
                                          repeat
                                             lerPagina (voltando);
                                             if voltando then voltando := voltarPagina;
                                          until not voltando;
                                    end;
                              end;
                           writeln;                           
                        end;
                   F4:  configura;
               end
           else
               case upcase(c1) of
                   NOFOCUS, GOTFOCUS: ;
                   'C':  configura;
                   'N':  trazerPagina ('', 'G');
                   'R':  recarregaPagina;
                   'L':  repeat
                             closeBmp; clrscr;
                             lerPagina (voltando);
                             if voltando then voltando := voltarPagina;
                         until not voltando;

                   'T':  if trazerPagina ('', 'G') then
                             repeat
                                 closeBmp; clrscr;
                                 lerPagina (voltando);
                                 if voltando then voltando := voltarPagina;
                             until not voltando;

                   'A':  carregarArquivo ('');
                   'V':  voltarPagina;
                   'S':  preferenciaCatalogo;
                   'O':  gravarOriginal (false);
                   'G':  gravarPagina;
                   'H':  chamarEditor;
                   'X':  exportarPagina;
                   'B':  armazenaVariasPaginas;
                   'D':  debug := not debug;
                   'E':  enviaPagina;
                   'P':  guardaPagPreferida;
                   ^F: processando := false; //Neno

                   ESC:  fim;
                   #$0d: ;
               else
                   mensagem ('WBOPERR', 1);  {'Opo invlida, aperte F1 para ajuda'}
               end;
       end;

    finaliza (falarAbertura); //Neno
end.
